﻿#include "model.h"

#define inches_to_mm 25.4
#define degrees_to_rad(a) ((a/360.0)*PI2)



model(example_1)
{
	difference();
		sphere(10);
		plane(0, 1, 0, 5);
		plane(0, -1, 0, 5);
	end();

	save_stl("/tmp/example_1_mesh.stl", .25, 5);
}


model(example_2)
{
	intersection();
		sphere(10);
		translate(-5, 0, 0);
		sphere(10);
		translate(5, 0, 0);
	end();

	save_stl("/tmp/example_2_mesh.stl", .25, 5);    
}

model(example_3)
{
	difference();
	
		sphere(10);
	
		plane(0, 1, 0, 5);
		plane(0, -1, 0, 5);

		for( double i = 0.0; i < 1.0; i += 1.0 / 32.0 )
		{
		cone(0.5, 0.5, 6);
		translate( sin( i * PI2 ) * 10 ,0 , cos( i * PI2 ) * 10 );
		}
		
	end();

	save_stl("/tmp/example_3_mesh.stl", .25, 5);
}


model(example_4)
{

	double plate_cx = 60.0;
	double plate_cz = 25.0;
	double text_border = 5.0;
	double text_cx,text_cy,text_cz;

	difference();

		box();
		translate(0,-0.5,0);
		scale(plate_cx,4,plate_cz); 

		text("C-CSG","/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-B.ttf",4.5);

		//center text on plate
		dimensions(&text_cx,&text_cy,&text_cz);         
		translate(-text_cx/2.0,-4,-text_cz/2.0); //center text on zero  
		scale((plate_cx-(text_border*2.0))/text_cx,1,(plate_cz-(text_border*2.0))/text_cz);  //scale to correct size to fill plate minus the border padding

	end();
	
	save_stl("/tmp/example_4_mesh.stl", .25, 5);
}

model(example_5)
{
	sphere(1);
	translate(5,0,0);
	dup();    
	translate(-10,0,0); 
	save_stl("/tmp/example_5_mesh.stl", .25, 5);	
}