﻿#include "model.h"

#define inches_to_mm 25.4
#define degrees_to_rad(a) ((a/360.0)*PI2)


#define cx 135.0
#define cy 33.0
#define cz 16.0
#define hole_spread 100.0
#define hole_diameter 4.0
#define hole_counter_sink_diameter 10.0
#define hole_counter_sink_depth 4.0



#define slots 4

#define slot_diameter 11.0
#define slot_length 20.0
#define slot_angle 30.0
#define slot_spacing 21.0

#define top_slot_cx 80.0
#define top_slot_cy 10.0



model(example_part)
{	
	
	difference();
		union();
			box();
			scale(cx,cz,cy);
	
			cone(cz/2.0,cz/2.0,cx);
			rotate(0,0,PI/2.0);
			translate(-cx/2.0,0,cy/2.0);			
	
			cone(cz/2.0,cz/2.0,cx);
			rotate(0,0,PI/2.0);
			translate(-cx/2.0,0,cy/2.0);			
			scale(1,1,-1);
		end();
	
		union();
			cone(hole_diameter/2.0,hole_diameter/2.0,cz*1.1);
			translate(-hole_spread/2.0,-cz*1.1/2.0,0);
			cone(hole_diameter/2.0,hole_diameter/2.0,cz*1.1);
			translate(hole_spread/2.0,-cz*1.1/2.0,0);
		
			cone(hole_diameter/2.0,hole_counter_sink_diameter/2.0,hole_counter_sink_depth);
			translate(-hole_spread/2.0,cz/2.0-hole_counter_sink_depth,0);
			cone(hole_diameter/2.0,hole_counter_sink_diameter/2.0,hole_counter_sink_depth);
			translate(hole_spread/2.0,cz/2.0-hole_counter_sink_depth,0);
		end();
		translate(0,0,1.5); //slight offset toward top
	
		union();
			cone(slot_diameter/2.0,slot_diameter/2.0, cz*1.1);
			translate(0,-cz*1.1/2.0,slot_length/2.0-slot_diameter/2.0);
			cone(slot_diameter/2.0,slot_diameter/2.0, cz*1.1);
			translate(0,-cz*1.1/2.0,-(slot_length/2.0-slot_diameter/2.0));
			box();
			scale(slot_diameter,cz*1.1,slot_length-slot_diameter);
		end();
		rotate(0,PI/8.0,0);
		OBJECT slot=cut();
		paste(slot);
		translate(-slot_spacing/2.0,0,0);
		paste(slot);
		translate(-(slot_spacing/2.0+slot_spacing),0,0);
		paste(slot);
		translate(slot_spacing/2.0,0,0);
		paste(slot);
		translate((slot_spacing/2.0+slot_spacing),0,0);
		
		box();
		scale(top_slot_cx,cz*1.1,top_slot_cy);
		translate(0,0,top_slot_cy/2.0+1.5);
		
		box();
		scale(85,11.0,25);
		translate(0,-5.0/2.0,1.5);
		
		box();
		scale(75,8,2);
		translate(0,(-cz/2.0)+5.0/2.0,-12);
		
	
	end();
	
	
	save_stl("/tmp/example_part.stl", 0.25, 5);	
}
