﻿#include "model.h"

#define inches_to_mm 25.4
#define degrees_to_rad(a) ((a/360.0)*PI2)



model(mic_capsule_holder)
{
	union();
		difference();
			box();
			scale(16,2,23);

			union();
				cone(1.5,1.5,30);
				translate(-10/2,-1.5,15.0/2.0);
				dup();
				scale(-1,1,1);
			end();
		
			dup();
			translate(0,0,-15);

		end();
		translate(0,-1,0);
	
		difference();
			union();
				box();
				translate(0,0.5,0);
				scale(7,15,7);
				
				cone(30.0/2.0,30.0/2.0,10);
				translate(0,-5,0);
				rotate(PI/2.0,0,0);
				translate(0,22,0);
				
			end();
			
			cone(26.0/2.0,26.0/2.0,10); //capsule sized cutter
			translate(0,-5,0);
			rotate(PI/2.0,0,0);
			translate(0,22,-2);
			
			cone(26.0/2.0,26.0/2.0,10); //capsule sized cutter
			translate(0,-5,0);
			scale(.9,1.1,.9);
			rotate(PI/2.0,0,0);
			translate(0,22,0);
			
		end();
	end();

	save_stl("/tmp/mic_capsule_holder.stl", .16, 8);
}


